
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "mem.h"


const int NumAllocs = 10000;


//
// Note: the timeGetTime are Windows NT millisecond timer functions.
// Although it is not documented, these functions are in the winmm.lib
// library.  This must be included in the project settings.
//
int
my_mem_alloc(void)
{
  const int AllocAmt = 64;
  int TimeStart, TimeEnd, TimeDelta;
  mem_manage mem;
  int i;

  TimeStart = timeGetTime();
  for (i = 0; i < NumAllocs; i++) {
    mem.mem_alloc( AllocAmt );
  } 

  TimeEnd = timeGetTime();
  TimeDelta = TimeEnd - TimeStart;
  printf("%d mem_allocs = %d\n", NumAllocs, TimeDelta );

  // mem.print_tree();
  printf("maximum binary tree branch = %d\n", mem.max_branch_size() );
  
  printf("number of element in the tree (should be %d) = %d\n",
	 NumAllocs, mem.count_tree());

  return timeGetTime();  // start time for destructor
}


void
main(void)
{
  int TimeStart, TimeEnd, TimeDelta;

  TimeStart = my_mem_alloc();
  TimeEnd = timeGetTime();    // Destructor completed
  TimeDelta = TimeEnd - TimeStart;
  printf("destructor = %d\n", TimeDelta );
}
