
#ifndef ORDLIST_H

#define ORDLIST_H

/*===============================<o>=====================================

  This software was written by Ian L. Kaplan, Chief Fat Bear, Bear Products
  International.  Use of this software, for any purpose, is granted on two
  conditions: 

   1. This copyright notice must be included with the software
      or any software derived from it.

   2. The risk of using this software is accepted by the user.  No
      warranty as to its usefulness or functionality is provided
      or implied.  The author and Bear Products International provides
      no support.

 ===============================<o>=====================================*/

/*

  The ordered_list object supports an ordered list (e.g., least to most).
  The get_mem function is virtual, allowing the class that inherits this
  one to determine how memory is allocated.

*/

class ordered_list {
  typedef struct ordered_list_struct {
    unsigned int size;
    void *mem;
    ordered_list_struct *next;
  } list_elem;

  list_elem *free_list;

 public:
  ordered_list(void);
  ~ordered_list(void);
  void *search_list( unsigned int &num_bytes );
  void add_to_list(void *addr, unsigned int size );
  void print_list(void);
  virtual void *get_mem( unsigned int num_bytes );
};


#endif
